Index: trunk/FACT++/configure
===================================================================
--- trunk/FACT++/configure	(revision 10403)
+++ trunk/FACT++/configure	(revision 10438)
@@ -747,4 +747,10 @@
 LTLIBOBJS
 LIBOBJS
+HAS_GUI_FALSE
+HAS_GUI_TRUE
+HAS_ROOT_QT_FALSE
+HAS_ROOT_QT_TRUE
+HAS_ROOT_FALSE
+HAS_ROOT_TRUE
 HAS_QT4_FALSE
 HAS_QT4_TRUE
@@ -767,4 +773,19 @@
 GROFF
 COLORDIFF
+ROOTLDFLAGS
+ROOTCPPFLAGS
+ROOTSOVERSION
+ROOTVERSION
+ROOTRPATH
+ROOTAUXCFLAGS
+ROOTAUXLIBS
+ROOTGLIBS
+ROOTLIBS
+ROOTCFLAGS
+ROOTINCDIR
+ROOTLIBDIR
+ROOTCINT
+ROOTEXEC
+ROOTCONF
 RCC4
 UIC4
@@ -1023,4 +1044,6 @@
 with_qt4_includes
 with_qt4_libraries
+with_root
+with_rootsys
 '
       ac_precious_vars='build_alias
@@ -1756,4 +1779,6 @@
   --with-qt4-includes     where the Qt 4 includes are
   --with-qt4-libraries    where the Qt 4 library is installed
+  --without-root          Disable root, i.e. disable gui support.
+  --with-rootsys          top of the ROOT installation directory
 
 Some influential environment variables:
@@ -4420,11 +4445,11 @@
   lt_cv_nm_interface="BSD nm"
   echo "int some_variable = 0;" > conftest.$ac_ext
-  (eval echo "\"\$as_me:4422: $ac_compile\"" >&5)
+  (eval echo "\"\$as_me:4447: $ac_compile\"" >&5)
   (eval "$ac_compile" 2>conftest.err)
   cat conftest.err >&5
-  (eval echo "\"\$as_me:4425: $NM \\\"conftest.$ac_objext\\\"\"" >&5)
+  (eval echo "\"\$as_me:4450: $NM \\\"conftest.$ac_objext\\\"\"" >&5)
   (eval "$NM \"conftest.$ac_objext\"" 2>conftest.err > conftest.out)
   cat conftest.err >&5
-  (eval echo "\"\$as_me:4428: output\"" >&5)
+  (eval echo "\"\$as_me:4453: output\"" >&5)
   cat conftest.out >&5
   if $GREP 'External.*some_variable' conftest.out > /dev/null; then
@@ -5632,5 +5657,5 @@
 *-*-irix6*)
   # Find out which ABI we are using.
-  echo '#line 5634 "configure"' > conftest.$ac_ext
+  echo '#line 5659 "configure"' > conftest.$ac_ext
   if { { eval echo "\"\$as_me\":${as_lineno-$LINENO}: \"$ac_compile\""; } >&5
   (eval $ac_compile) 2>&5
@@ -7560,9 +7585,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:7562: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:7587: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:7566: \$? = $ac_status" >&5
+   echo "$as_me:7591: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
@@ -7899,9 +7924,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:7901: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:7926: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:7905: \$? = $ac_status" >&5
+   echo "$as_me:7930: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
@@ -8004,9 +8029,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8006: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8031: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:8010: \$? = $ac_status" >&5
+   echo "$as_me:8035: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -8059,9 +8084,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8061: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8086: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:8065: \$? = $ac_status" >&5
+   echo "$as_me:8090: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -10443,5 +10468,5 @@
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<_LT_EOF
-#line 10445 "configure"
+#line 10470 "configure"
 #include "confdefs.h"
 
@@ -10539,5 +10564,5 @@
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<_LT_EOF
-#line 10541 "configure"
+#line 10566 "configure"
 #include "confdefs.h"
 
@@ -12495,9 +12520,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:12497: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:12522: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:12501: \$? = $ac_status" >&5
+   echo "$as_me:12526: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
@@ -12594,9 +12619,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:12596: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:12621: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:12600: \$? = $ac_status" >&5
+   echo "$as_me:12625: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -12646,9 +12671,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:12648: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:12673: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:12652: \$? = $ac_status" >&5
+   echo "$as_me:12677: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -21531,5 +21556,5 @@
 
 		cat > conftest.$ac_ext <<EOF
-#line 21533 "configure"
+#line 21558 "configure"
 #include "confdefs.h"
 #include <qglobal.h>
@@ -21694,31 +21719,244 @@
 
 
-#AC_CHECK_PROG(QT4_MOC, moc, moc,
-#   AC_MSG_ERROR([QT4 executable 'moc' not found in path.]))
-#AC_CHECK_PROG(QT4_UIC, uic, uic,
-#   AC_MSG_ERROR([QT4 executable 'moc' not found in path.]))
-
 ######################################################################
 # ROOT SUPPORT
 ######################################################################
 
-# ROOT_PATH([5.12/00, [ACTION-IF-FOUND, [ACTION-IF-NOT-FOUND]]])
-# ROOT_PATH([5.12/00])
-# ROOT_PATH(3.03/05, , AC_MSG_ERROR(Your ROOT version is too old))
-# ROOT_PATH(, AC_DEFINE([HAVE_ROOT]))
-
-# ROOTCONF           full path to root-config
-# ROOTEXEC           full path to root
-# ROOTCINT           full path to rootcint
-# ROOTLIBDIR         Where the ROOT libraries are
-# ROOTINCDIR         Where the ROOT headers are
-# ROOTETCDIR         Where the ROOT configuration is
-# ROOTCFLAGS         Extra compiler flags
-# ROOTLIBS           ROOT basic libraries
-# ROOTGLIBS          ROOT basic + GUI libraries
-# ROOTAUXLIBS        Auxilary libraries and linker flags for ROOT
-# ROOTAUXCFLAGS      Auxilary compiler flags
-# ROOTRPATH          Same as ROOTLIBDIR
-
+
+# Check whether --with-root was given.
+if test "${with_root+set}" = set; then :
+  withval=$with_root;
+else
+
+
+# Check whether --with-rootsys was given.
+if test "${with_rootsys+set}" = set; then :
+  withval=$with_rootsys; user_rootsys=$withval
+else
+  user_rootsys="none"
+fi
+
+  if test ! x"$user_rootsys" = xnone; then
+    rootbin="$user_rootsys"
+  elif test ! x"$ROOTSYS" = x ; then
+    rootbin="$ROOTSYS/bin"
+  else
+   rootbin=$PATH
+  fi
+
+  { $as_echo "$as_me:${as_lineno-$LINENO}: checking for root in" >&5
+$as_echo_n "checking for root in... " >&6; }
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $rootbin" >&5
+$as_echo "$rootbin" >&6; }
+
+  # Extract the first word of "root-config ", so it can be a program name with args.
+set dummy root-config ; ac_word=$2
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
+$as_echo_n "checking for $ac_word... " >&6; }
+if test "${ac_cv_path_ROOTCONF+set}" = set; then :
+  $as_echo_n "(cached) " >&6
+else
+  case $ROOTCONF in
+  [\\/]* | ?:[\\/]*)
+  ac_cv_path_ROOTCONF="$ROOTCONF" # Let the user override the test with a path.
+  ;;
+  *)
+  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
+for as_dir in $rootbin
+do
+  IFS=$as_save_IFS
+  test -z "$as_dir" && as_dir=.
+    for ac_exec_ext in '' $ac_executable_extensions; do
+  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+    ac_cv_path_ROOTCONF="$as_dir/$ac_word$ac_exec_ext"
+    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
+    break 2
+  fi
+done
+  done
+IFS=$as_save_IFS
+
+  test -z "$ac_cv_path_ROOTCONF" && ac_cv_path_ROOTCONF="no"
+  ;;
+esac
+fi
+ROOTCONF=$ac_cv_path_ROOTCONF
+if test -n "$ROOTCONF"; then
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ROOTCONF" >&5
+$as_echo "$ROOTCONF" >&6; }
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+fi
+
+
+  # Extract the first word of "root ", so it can be a program name with args.
+set dummy root ; ac_word=$2
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
+$as_echo_n "checking for $ac_word... " >&6; }
+if test "${ac_cv_path_ROOTEXEC+set}" = set; then :
+  $as_echo_n "(cached) " >&6
+else
+  case $ROOTEXEC in
+  [\\/]* | ?:[\\/]*)
+  ac_cv_path_ROOTEXEC="$ROOTEXEC" # Let the user override the test with a path.
+  ;;
+  *)
+  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
+for as_dir in $rootbin
+do
+  IFS=$as_save_IFS
+  test -z "$as_dir" && as_dir=.
+    for ac_exec_ext in '' $ac_executable_extensions; do
+  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+    ac_cv_path_ROOTEXEC="$as_dir/$ac_word$ac_exec_ext"
+    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
+    break 2
+  fi
+done
+  done
+IFS=$as_save_IFS
+
+  test -z "$ac_cv_path_ROOTEXEC" && ac_cv_path_ROOTEXEC="no"
+  ;;
+esac
+fi
+ROOTEXEC=$ac_cv_path_ROOTEXEC
+if test -n "$ROOTEXEC"; then
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ROOTEXEC" >&5
+$as_echo "$ROOTEXEC" >&6; }
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+fi
+
+
+  # Extract the first word of "rootcint ", so it can be a program name with args.
+set dummy rootcint ; ac_word=$2
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
+$as_echo_n "checking for $ac_word... " >&6; }
+if test "${ac_cv_path_ROOTCINT+set}" = set; then :
+  $as_echo_n "(cached) " >&6
+else
+  case $ROOTCINT in
+  [\\/]* | ?:[\\/]*)
+  ac_cv_path_ROOTCINT="$ROOTCINT" # Let the user override the test with a path.
+  ;;
+  *)
+  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
+for as_dir in $rootbin
+do
+  IFS=$as_save_IFS
+  test -z "$as_dir" && as_dir=.
+    for ac_exec_ext in '' $ac_executable_extensions; do
+  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+    ac_cv_path_ROOTCINT="$as_dir/$ac_word$ac_exec_ext"
+    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
+    break 2
+  fi
+done
+  done
+IFS=$as_save_IFS
+
+  test -z "$ac_cv_path_ROOTCINT" && ac_cv_path_ROOTCINT="no"
+  ;;
+esac
+fi
+ROOTCINT=$ac_cv_path_ROOTCINT
+if test -n "$ROOTCINT"; then
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ROOTCINT" >&5
+$as_echo "$ROOTCINT" >&6; }
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+fi
+
+
+
+  if test ! x"$ROOTCONF" = "xno" && \
+     test ! x"$ROOTCINT" = "xno" ; then
+
+    # define some variables
+    ROOTLIBDIR=`$ROOTCONF --libdir`
+    ROOTINCDIR=`$ROOTCONF --incdir`
+#    ROOTETCDIR=`$ROOTCONF --etcdir`
+    ROOTCFLAGS=`$ROOTCONF --noauxcflags --cflags`
+    ROOTLIBS=`$ROOTCONF --noauxlibs --noldflags --libs`
+    ROOTGLIBS=`$ROOTCONF --noauxlibs --noldflags --glibs`
+    ROOTAUXCFLAGS=`$ROOTCONF --auxcflags`
+    ROOTAUXLIBS=`$ROOTCONF --auxlibs`
+    ROOTRPATH=$ROOTLIBDIR
+    ROOTVERSION=`$ROOTCONF --version`
+    ROOTSOVERSION=`dirname $ROOTVERSION`
+
+    if test 5.12/00 ; then
+      { $as_echo "$as_me:${as_lineno-$LINENO}: checking wether ROOT version >= 5.12/00" >&5
+$as_echo_n "checking wether ROOT version >= 5.12/00... " >&6; }
+      vers=`$ROOTCONF --version | tr './' ' ' | awk 'BEGIN { FS = " "; } { printf "%d", ($''1 * 1000 + $''2) * 1000 + $''3;}'`
+      requ=`echo 5.12/00 | tr './' ' ' | awk 'BEGIN { FS = " "; } { printf "%d", ($''1 * 1000 + $''2) * 1000 + $''3;}'`
+      if test $vers -lt $requ ; then
+        { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+	no_root="yes"
+      else
+        { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+$as_echo "yes" >&6; }
+      fi
+    fi
+  else
+    # otherwise, we say no_root
+    no_root="yes"
+  fi
+
+
+
+#  AC_SUBST(ROOTETCDIR)
+
+
+
+
+
+
+
+
+
+  if test "x$no_root" = "x" ; then
+    :
+  else
+    :
+  fi
+
+
+fi
+
+
+HAVE_ROOT_QT=no
+
+if test "$ROOTEXEC" != no ;
+then
+
+   ROOTCPPFLAGS=$ROOTCFLAGS" "$ROOTAUXCFLAGS
+   ROOTLDFLAGS="-L"$ROOTLIBDIR" -lGQt "
+
+
+
+  feat=qt
+  res=`$ROOTCONF --has-$feat`
+  if test "x$res" = "xyes" ; then
+    HAVE_ROOT_QT=yes
+  else
+    :
+  fi
+
+  { $as_echo "$as_me:${as_lineno-$LINENO}: checking whether root was built with --with-qt" >&5
+$as_echo_n "checking whether root was built with --with-qt... " >&6; }
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $res" >&5
+$as_echo "$res" >&6; }
+
+
+
+
+
+fi
 
 ######################################################################
@@ -21967,4 +22205,28 @@
   HAS_QT4_TRUE='#'
   HAS_QT4_FALSE=
+fi
+
+ if test "$ROOTEXEC" != no; then
+  HAS_ROOT_TRUE=
+  HAS_ROOT_FALSE='#'
+else
+  HAS_ROOT_TRUE='#'
+  HAS_ROOT_FALSE=
+fi
+
+ if test "$HAVE_ROOT_QT" = yes; then
+  HAS_ROOT_QT_TRUE=
+  HAS_ROOT_QT_FALSE='#'
+else
+  HAS_ROOT_QT_TRUE='#'
+  HAS_ROOT_QT_FALSE=
+fi
+
+ if test "$QT4_VERSION" -a "$HAVE_ROOT_QT" = yes; then
+  HAS_GUI_TRUE=
+  HAS_GUI_FALSE='#'
+else
+  HAS_GUI_TRUE='#'
+  HAS_GUI_FALSE=
 fi
 
@@ -22254,4 +22516,16 @@
 if test -z "${HAS_QT4_TRUE}" && test -z "${HAS_QT4_FALSE}"; then
   as_fn_error $? "conditional \"HAS_QT4\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${HAS_ROOT_TRUE}" && test -z "${HAS_ROOT_FALSE}"; then
+  as_fn_error $? "conditional \"HAS_ROOT\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${HAS_ROOT_QT_TRUE}" && test -z "${HAS_ROOT_QT_FALSE}"; then
+  as_fn_error $? "conditional \"HAS_ROOT_QT\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${HAS_GUI_TRUE}" && test -z "${HAS_GUI_FALSE}"; then
+  as_fn_error $? "conditional \"HAS_GUI\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
@@ -24610,11 +24884,15 @@
 fi
 if test -n "$QT4_VERSION"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}:  GUI support enabled    / QT4 toolkit      found: yes" >&5
-$as_echo "$as_me:  GUI support enabled    / QT4 toolkit      found: yes" >&6;}
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}:  GUI support enabled    / QT4 toolkit      found: no" >&5
-$as_echo "$as_me:  GUI support enabled    / QT4 toolkit      found: no" >&6;}
-
-fi
+  { $as_echo "$as_me:${as_lineno-$LINENO}:  QT4 support enabled    /  QT4 toolkit     found: yes" >&5
+$as_echo "$as_me:  QT4 support enabled    /  QT4 toolkit     found: yes" >&6;}
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}:  QT4 support enabled    /  QT4 toolkit     found: no" >&5
+$as_echo "$as_me:  QT4 support enabled    /  QT4 toolkit     found: no" >&6;}
+
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}:  ROOT support enabled   /  root >= 5.12/00 found: $ROOTEXEC" >&5
+$as_echo "$as_me:  ROOT support enabled   /  root >= 5.12/00 found: $ROOTEXEC" >&6;}
+{ $as_echo "$as_me:${as_lineno-$LINENO}:  ROOT built with --with-qt                 found: $HAVE_ROOT_QT" >&5
+$as_echo "$as_me:  ROOT built with --with-qt                 found: $HAVE_ROOT_QT" >&6;}
 if test -n "$QT4_VERSION"; then
 
@@ -24645,4 +24923,28 @@
 
 fi
+if test -n "$QT4_VERSION"; then
+
+   { $as_echo "$as_me:${as_lineno-$LINENO}: " >&5
+$as_echo "$as_me: " >&6;}
+   { $as_echo "$as_me:${as_lineno-$LINENO}: --------------------------------------------------------------------" >&5
+$as_echo "$as_me: --------------------------------------------------------------------" >&6;}
+   { $as_echo "$as_me:${as_lineno-$LINENO}: " >&5
+$as_echo "$as_me: " >&6;}
+   { $as_echo "$as_me:${as_lineno-$LINENO}:  ROOTVERSION   = $ROOTVERSION" >&5
+$as_echo "$as_me:  ROOTVERSION   = $ROOTVERSION" >&6;}
+   { $as_echo "$as_me:${as_lineno-$LINENO}: " >&5
+$as_echo "$as_me: " >&6;}
+   { $as_echo "$as_me:${as_lineno-$LINENO}:  ROOTEXEC      = $ROOTEXEC" >&5
+$as_echo "$as_me:  ROOTEXEC      = $ROOTEXEC" >&6;}
+   { $as_echo "$as_me:${as_lineno-$LINENO}:  ROOTCONF      = $ROOTCONF" >&5
+$as_echo "$as_me:  ROOTCONF      = $ROOTCONF" >&6;}
+   { $as_echo "$as_me:${as_lineno-$LINENO}:  ROOTCINT      = $ROOTCINT" >&5
+$as_echo "$as_me:  ROOTCINT      = $ROOTCINT" >&6;}
+   { $as_echo "$as_me:${as_lineno-$LINENO}:  ROOTCPPFLAGS  = $ROOTCPPFLAGS" >&5
+$as_echo "$as_me:  ROOTCPPFLAGS  = $ROOTCPPFLAGS" >&6;}
+   { $as_echo "$as_me:${as_lineno-$LINENO}:  ROOTLDFLAGS   = $ROOTLDFLAGS" >&5
+$as_echo "$as_me:  ROOTLDFLAGS   = $ROOTLDFLAGS" >&6;}
+
+fi
 { $as_echo "$as_me:${as_lineno-$LINENO}: " >&5
 $as_echo "$as_me: " >&6;}
@@ -24710,8 +25012,25 @@
 { $as_echo "$as_me:${as_lineno-$LINENO}: " >&5
 $as_echo "$as_me: " >&6;}
-
-#[AC_]PACKAGE_NAME
-#[AC_]PACKAGE_TARNAME
-#[AC_]PACKAGE_VERSION
-#[AC_]PACKAGE_STRING
-#[AC_]PACKAGE_BUGREPORT
+{ $as_echo "$as_me:${as_lineno-$LINENO}: --------------------------------------------------------------------" >&5
+$as_echo "$as_me: --------------------------------------------------------------------" >&6;}
+{ $as_echo "$as_me:${as_lineno-$LINENO}: " >&5
+$as_echo "$as_me: " >&6;}
+if test "$ROOTEXEC" != no; then
+  if test "$HAVE_ROOT_QT" = yes; then
+  :
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  root found but it was built without the --with-qt option" >&5
+$as_echo "$as_me: WARNING:  root found but it was built without the --with-qt option" >&2;}
+
+fi
+
+fi
+if test "$QT4_VERSION" -a "$HAVE_ROOT_QT" = yes; then
+  :
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  Either QT4 or qt-root is missing: GUI disabled!" >&5
+$as_echo "$as_me: WARNING:  Either QT4 or qt-root is missing: GUI disabled!" >&2;}
+
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: " >&5
+$as_echo "$as_me: " >&6;}