Index: trunk/FACT++/configure.ac
===================================================================
--- trunk/FACT++/configure.ac	(revision 10445)
+++ trunk/FACT++/configure.ac	(revision 10458)
@@ -125,10 +125,7 @@
 LDFLAGS+=" "$MOTIF_LDFLAGS" "
 
-#AC_CHECK_HEADERS([Mrm/MrmAppl.h], [], 
-#   [                             
-#      echo "Error! Mrm/MrmAppl.h not properly installed, needed to compile did (you need most probably lesstif2-dev)." 
-#      exit -1
-#   ]
-#)
+AM_COND_IF(HAS_LIBXP,, 
+      AC_MSG_WARN([ Motif/lesstif not found!])
+)
 
 ######################################################################
@@ -280,4 +277,7 @@
 AM_CONDITIONAL(HAS_GUI,       [test "$QT4_VERSION" -a "$HAVE_ROOT_QT" = yes])
 
+AM_CONDITIONAL(IS_FALSE,      [test "x" = "y"])
+AM_CONDITIONAL(IS_TRUE,       [test "x" = "x"])
+
 ##########################################################################
 # print summary
@@ -297,5 +297,5 @@
 AC_MSG_NOTICE([ BOOST_CPPFLAGS = $BOOST_CPPFLAGS])
 AC_MSG_NOTICE([ BOOST_LDFLAGS  = $BOOST_LDFLAGS])
-   AC_MSG_NOTICE()
+AC_MSG_NOTICE()
 AM_COND_IF(HAS_QT4, [
    AC_MSG_NOTICE(--------------------------------------------------------------------)
@@ -322,38 +322,41 @@
    AC_MSG_NOTICE([ ROOTCPPFLAGS  = $ROOTCPPFLAGS])
    AC_MSG_NOTICE([ ROOTLDFLAGS   = $ROOTLDFLAGS])
-AC_MSG_NOTICE()
+   AC_MSG_NOTICE()
 ],[])
 AC_MSG_NOTICE(--------------------------------------------------------------------)
 AC_MSG_NOTICE()
-
+AM_COND_IF(HAS_LIBXP,
+   AC_MSG_NOTICE([ Motif/lesstif          / 'Xm/Xm.h' 'libXp' found: yes]),
+   AC_MSG_NOTICE([ Motif/lesstif          / 'Xm/Xm.h' 'libXp' found: no])
+)
 AM_COND_IF(HAS_COLORDIFF,
-   AC_MSG_NOTICE([ colored svn diff       / 'colordiff'      found: yes]),
-   AC_MSG_NOTICE([ colored svn diff       / 'colordiff'      found: no])
+   AC_MSG_NOTICE([ colored svn diff       / 'colordiff'       found: yes]),
+   AC_MSG_NOTICE([ colored svn diff       / 'colordiff'       found: no])
 )
 AM_COND_IF(HAS_HELP2MAN,[
-   AC_MSG_NOTICE([ man-pages enabled      / 'help2man'       found: $HELP2MAN])
+   AC_MSG_NOTICE([ man-pages enabled      / 'help2man'        found: $HELP2MAN])
    AM_COND_IF(HAS_GROFF,
-      AC_MSG_NOTICE([ build of html enabled  / 'groff'          found: yes])
-      AC_MSG_NOTICE([ build of pdf  enabled  / 'ps2pdf'         found: $PS2PDF]),
-      AC_MSG_NOTICE([ build of html and pdf  / 'groff'          found: no])
+      AC_MSG_NOTICE([ build of html enabled  / 'groff'           found: yes])
+      AC_MSG_NOTICE([ build of pdf  enabled  / 'ps2pdf'          found: $PS2PDF]),
+      AC_MSG_NOTICE([ build of html and pdf  / 'groff'           found: no])
    )
 ],[
-   AC_MSG_NOTICE([ man, html, pdf enabled / 'help2man'       found: no])
+   AC_MSG_NOTICE([ man, html, pdf enabled / 'help2man'        found: no])
 ])   
 
 AM_COND_IF(HAS_DOXYGEN,
-   AC_MSG_NOTICE([ doxygen docu enabled   / 'doxygen'        found: $DX_DOXYGEN]),
-   AC_MSG_NOTICE([ doxygen docu enabled   / 'doxygen'        found: no])
+   AC_MSG_NOTICE([ doxygen docu enabled   / 'doxygen'         found: $DX_DOXYGEN]),
+   AC_MSG_NOTICE([ doxygen docu enabled   / 'doxygen'         found: no])
 )
 AM_COND_IF(HAS_DOT,
-   AC_MSG_NOTICE([ doxygen graphs enabled / 'dot' (graphviz) found: $DX_DOT]),
-   AC_MSG_NOTICE([ doxagen graphs enabled / 'dot' (graphviz) found: no])
+   AC_MSG_NOTICE([ doxygen graphs enabled / 'dot' (graphviz)  found: $DX_DOT]),
+   AC_MSG_NOTICE([ doxygen graphs enabled / 'dot' (graphviz)  found: no])
 )
 AM_COND_IF(HAS_QT4,
-   AC_MSG_NOTICE([ QT4 support enabled    /  QT4 toolkit     found: yes]),
-   AC_MSG_NOTICE([ QT4 support enabled    /  QT4 toolkit     found: no])
-)
-AC_MSG_NOTICE([ ROOT support enabled   /  root >= 5.12/00 found: $ROOTEXEC])
-AC_MSG_NOTICE([ ROOT built with --with-qt                 found: $HAVE_ROOT_QT])
+   AC_MSG_NOTICE([ QT4 support enabled    /  QT4 toolkit      found: yes]),
+   AC_MSG_NOTICE([ QT4 support enabled    /  QT4 toolkit      found: no])
+)
+AC_MSG_NOTICE([ ROOT support enabled   /  root >= 5.12/00  found: $ROOTEXEC])
+AC_MSG_NOTICE([ ROOT built with --with-qt                  found: $HAVE_ROOT_QT])
 AC_MSG_NOTICE()
 AC_MSG_NOTICE(--------------------------------------------------------------------)
@@ -361,13 +364,13 @@
 AC_MSG_NOTICE([Suggestions and hits:])
 AC_MSG_NOTICE()
-AC_MSG_NOTICE([  - Add 'V=1' to you make-call to switch on verbose output.])
-AC_MSG_NOTICE([  - Do not try to create man-pages with doxygen,])
-AC_MSG_NOTICE([    it does most probably not work.])
+AC_MSG_NOTICE([ - Add 'V=1' to you make-call to switch on verbose output.])
+AC_MSG_NOTICE([ - Do not try to create man-pages with doxygen,])
+AC_MSG_NOTICE([   it does most probably not work.])
 AM_COND_IF(HAS_COLORGCC,,
-   AC_MSG_NOTICE([  - Install colorgcc to get colored compiler output.])
-)
-AC_MSG_NOTICE([  - If you send me a bug report about:])
-AC_MSG_NOTICE([    + configure please attach the file config.log])
-AC_MSG_NOTICE([    + make please send me the output of 'make V=1'])
+   AC_MSG_NOTICE([ - Install colorgcc to get colored compiler output.])
+)
+AC_MSG_NOTICE([ - If you send me a bug report about:])
+AC_MSG_NOTICE([   + configure: please attach the file config.log])
+AC_MSG_NOTICE([   + make: please send me the output of 'make V=1'])
 AC_MSG_NOTICE()
 AC_MSG_NOTICE(--------------------------------------------------------------------)
@@ -394,6 +397,9 @@
 AC_MSG_NOTICE(--------------------------------------------------------------------)
 AC_MSG_NOTICE()
+AM_COND_IF(HAS_LIBXP,, 
+      AC_MSG_WARN([ Motif/lesstif not found. The dim gui did will not be built!])
+)
 AM_COND_IF(HAS_ROOT,  
-   [AM_COND_IF(HAS_ROOT_QT, [], 
+   [AM_COND_IF(HAS_ROOT_QT,, 
       AC_MSG_WARN([ root found but it was built without the --with-qt option])
    )]